@inject Microsoft.Extensions.Localization.IStringLocalizer<App> Localize
@using Microsoft.AspNetCore.Components.Forms
@inject DataService DS
@inject SessionData SD
@inject IJSRuntime JSRuntime
@using BioMap
@implements IDisposable

<Row>
  <Column>
    <Field Horizontal="true">
      <FieldLabel ColumnSize="ColumnSize.IsFull.OnTablet.Is3.OnDesktop">@Localize["Place filter"]</FieldLabel>
      <FieldBody ColumnSize="ColumnSize.IsFull.OnTablet.Is9.OnDesktop">
        <Addons>
          <Addon AddonType="AddonType.Start">
            <Dropdown @ref="dropdown">
              <Button Color="Color.Primary" Clicked="@((e)=>dropdown.Toggle(""))"><Icon Name="IconName.AngleDown" /></Button>
              <DropdownMenu>
                <DropdownItem Clicked="@((e)=>{SD.Filters.PlaceFilter="";dropdown.Hide();})"><Icon Name="IconName.Clear" /> @Localize["Clear"]</DropdownItem>
                <DropdownDivider Style="min-width:400px"></DropdownDivider>
                @foreach (var place in DS.GetPlaces(SD, null, true))
                {
                  <Button Color="SD.Filters.PlaceFilter.Contains(place.Name)?Color.Primary:Color.Light"
                        Class="small"
                        Clicked="(e)=>TogglePlace(place.Name)">
                    @place.Name
                  </Button>
                }
              </DropdownMenu>
            </Dropdown>
          </Addon>
          <Addon AddonType="AddonType.Body">
            <TextEdit Text="@SD.Filters.PlaceFilter" TextChanged="@((e)=>{ SD.Filters.PlaceFilter=(e==null)?"":e; })" />
          </Addon>
        </Addons>
      </FieldBody>
    </Field>
  </Column>
</Row>

@code {
  Dropdown dropdown;
  private void TogglePlace(string sPlaceName)
  {
    var lPlaces = new List<string>(SD.Filters.PlaceFilter.Split(Filters.SeparateChars));
    int idx = lPlaces.IndexOf(sPlaceName);
    if (idx < 0)
    {
      lPlaces.Add(sPlaceName);
    }
    else
    {
      lPlaces.RemoveAt(idx);
    }
    lPlaces.Sort();
    var sb = new System.Text.StringBuilder();
    lPlaces.ForEach((p) => sb.Append(p + " "));
    SD.Filters.PlaceFilter = sb.ToString().Trim();
  }

  protected override void OnInitialized() {
    SD.Filters.FilterChanged += this.FilterChanged;
  }

  private void FilterChanged(object sender, EventArgs e) {
    this.InvokeAsync(() => this.StateHasChanged());
  }

  public void Dispose() {
    SD.Filters.FilterChanged -= this.FilterChanged;
  }
}
